> For the complete documentation index, see [llms.txt](https://docs.sonoransoftware.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.sonoransoftware.com/radio/developer-documentation/developer-documentation/api-endpoints/users/set-member-permissions.md).

# Set Member Permissions

Batch update member permission bitmasks and private-channel access.

## Set Member Permissions

<mark style="color:green;">`POST`</mark> `/api/servers/:id/members/permissions`

This endpoint updates one or more members' community permissions. You can also use it to grant or remove access to specific private channels.

**Headers**

| Name         | Value              |
| ------------ | ------------------ |
| Content-Type | `application/json` |

**URL Parameters**

| Name | Type   | Description  |
| ---- | ------ | ------------ |
| `id` | string | Community ID |

**Body**

| Name        | Type         | Description                 |
| ----------- | ------------ | --------------------------- |
| `apiKey`    | string       | Community API key           |
| `userPerms` | object array | Permission changes to apply |

**`userPerms` object**

| Name           | Type         | Description                             |
| -------------- | ------------ | --------------------------------------- |
| `accId`        | string       | Account UUID                            |
| `perm`         | number       | Permission value                        |
| `profilePerms` | object array | Optional private-channel access updates |

**`profilePerms` object**

| Name        | Type    | Description                              |
| ----------- | ------- | ---------------------------------------- |
| `profileId` | number  | Channel/profile ID                       |
| `canJoin`   | boolean | Whether the member may join that profile |

**Permission Values**

| Permission                | Value |
| ------------------------- | ----- |
| `ADMIN`                   | `1`   |
| `COMM_KICK`               | `2`   |
| `COMM_BAN`                | `4`   |
| `RADIO_MOVE_CLIENT`       | `8`   |
| `RADIO_KICK`              | `16`  |
| `COMM_APPROVE`            | `32`  |
| `SET_DISPLAYNAME`         | `64`  |
| `COMM_SET_DISPLAYNAME`    | `128` |
| `RADIO_PLAY_TONES`        | `256` |
| `RADIO_TALKOVER_OVERRIDE` | `512` |

Combine multiple permissions by adding the values together.

**Example Body**

```json
{
  "apiKey": "your-community-api-key",
  "userPerms": [
    {
      "accId": "91de0ce8-c571-11e9-9714-5600023b2434",
      "perm": 34,
      "profilePerms": [
        {
          "profileId": 12,
          "canJoin": true
        }
      ]
    }
  ]
}
```

In this example, `34` grants `COMM_KICK` (`2`) and `COMM_APPROVE` (`32`).

**Response**

{% tabs %}
{% tab title="200" %}

```json
{
  "result": "ok"
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.sonoransoftware.com/radio/developer-documentation/developer-documentation/api-endpoints/users/set-member-permissions.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
